/* 
 * Setup tables and sprocs for Reindexing time bomb
 */

use [master]
go

IF NOT DB_ID('ReindexTimeBomb') IS NULL 
	DROP DATABASE [ReindexTimeBomb];
GO

CREATE DATABASE [ReindexTimeBomb];
GO

use [ReindexTimeBomb]
GO



/* Create our table */
CREATE TABLE BIG_MESSAGE_TABLE (
	MessageId BIGINT IDENTITY NOT NULL,
	[Body] NVARCHAR (MAX) NULL,
	CONSTRAINT PK_BIG_MESSAGE_TABLE 
		PRIMARY KEY CLUSTERED (MessageId)
)
GO





/* Fill the table, might take a few seconds */
SET NOCOUNT ON
INSERT BIG_MESSAGE_TABLE ( Body )
VALUES (newid())
go 1000



/* Create a simple procedure */
CREATE PROCEDURE dbo.s_BIG_MESSAGE_TABLE_Get
	@MessageId INT
AS

SET NOCOUNT ON

SELECT [Body]
FROM BIG_MESSAGE_TABLE
WHERE MessageId = @MessageId
	
go




/* example usage */
exec s_BIG_MESSAGE_TABLE_Get 42
go
