use [ReindexTimeBomb]
GO

-- try running a query when someone else has a "SCH-m" lock:
exec s_BIG_MESSAGE_TABLE_Get 98
-- it's blocked, when you're done waiting, cancel 
go


-- Let's try something novel... 
-- Let's create an empty temp table with the same schema
CREATE TABLE BIG_MESSAGE_TABLE_Temp (
	MessageId bigint NOT NULL,
	[Body] NVARCHAR (MAX) NULL,
	CONSTRAINT PK_BIG_MESSAGE_TABLE_Temp 
		PRIMARY KEY CLUSTERED (MessageId)
)
GO



-- Good, now lets alter the procedure to point to the new empty table
ALTER PROCEDURE dbo.s_BIG_MESSAGE_TABLE_Get
	@MessageId INT
AS

SET NOCOUNT ON

SELECT [Body]
FROM BIG_MESSAGE_TABLE_Temp
WHERE MessageId = @MessageId
	
go
-- blocked... cancel this statement



-- Altering doesn't work... Can we drop it and recreate it?
DROP PROCEDURE s_BIG_MESSAGE_TABLE_Get
-- blocked... cancel this statement



-- Let's try something *else* that's novel... 
CREATE SCHEMA obsolete
go

ALTER SCHEMA obsolete TRANSFER dbo.s_BIG_MESSAGE_TABLE_Get
go




-- That worked! The old sproc is out of the way... Let's continue
CREATE PROCEDURE dbo.s_BIG_MESSAGE_TABLE_Get
	@MessageId INT
AS

SET NOCOUNT ON

SELECT [Body]
FROM BIG_MESSAGE_TABLE_Temp
WHERE MessageId = @MessageId
	
go


-- Success! Let's see it work
exec s_BIG_MESSAGE_TABLE_Get 123