/* Create the test database */
use [master]
go

IF NOT DB_ID('mytest') IS NULL 
	DROP DATABASE mytest;
GO

CREATE DATABASE mytest;
GO

use mytest
GO




/* Setup table */
create table MyTest
(
    Column1 varchar(100),
    Column2 text 
)
go

insert top (10000) mytest (Column1, Column2)
select REPLICATE('a', 100), REPLICATE('a', 100)
from sys.syscolumns a, sys.syscolumns b
go





-- start collecting TLogs:
ALTER DATABASE [Mytest] SET RECOVERY FULL WITH NO_WAIT
backup database [MyTest] to disk = 'nul:'
go

-- clear Tlogs
checkpoint
backup log [mytest] to disk = 'nul:'








-- processes only metadata (text ==> varchar(max))
alter table mytest
alter column Column2 varchar(max)





-- Examine TLog for the above statement
declare @transactionId nvarchar(28)
select TOP 1 @transactionId = [Transaction Id]
from fn_dblog(null, null)
where [Transaction Name] = 'ALTER TABLE'

select count(1), AllocUnitName
from fn_dblog(null, null)
where [Transaction Id] = @transactionId
group by AllocUnitName
go





-- clear Tlogs
checkpoint
backup log [mytest] to disk = 'nul:'






-- processes every page: (varchar(100) ==> varchar(max))
alter table mytest
alter column Column1 varchar(max)






-- Examine TLog for the above statement
declare @transactionId nvarchar(28)
select TOP 1 @transactionId = [Transaction Id]
from fn_dblog(null, null)
where [Transaction Name] = 'ALTER TABLE'

select count(1), AllocUnitName
from fn_dblog(null, null)
where [Transaction Id] = @transactionId
group by AllocUnitName
go
